CON
    _clkmode = xtal1 + pll16x                           
    _xinfreq = 5_000_000

    #0,MSBPRE,LSBPRE,MSBPOST,LSBPOST                                            'Used for SHIFTIN routines
    #4,LSBFIRST,MSBFIRST                                                        'Used for SHIFTOUT routines
    #0,Dpin,Cpin,SLpin,#8,Bits                                                  'Set Dpin,Cpin,SLpin and Bit constant
    
VAR     long          DataValue

OBJ     SPI     : "SPI Engine"

PUB start
{
                        Once called from Spin, SHIFTIN or SHIFTOUT remains running in its own COG.
                        If SHIFTIN or SHIFTOUT are called with 'Bits' set to Zero, then the COG will shut
                        down.  Another way to shut the COG down is to call 'stop' from Spin.
}          
'------------------------------------------------------------------------------------------------------------------------------
    DataValue := %10001011                                                      'DEBUG - Test value

    SPI.SHIFTOUT(Dpin, Cpin, MSBFIRST, Bits, DataValue)                         'Send SHIFTOUT DataVAlue
    
                                                                                'DEBUG - Tested with 74HCT164
                                                                                '        for MSBFIRST and LSBFIRST functions
'------------------------------------------------------------------------------------------------------------------------------
    dira[23..16] := %11111111                                                   'DEBUG - Make ALL LED's outputs

    dira[SLpin] := %1                                                           'Set Shift / Load pin as an output
    repeat
      outa[SLpin] := %1                                                         'Set Shift / Load pin in shift mode "1"
      DataValue := SPI.SHIFTIN(Dpin, Cpin, MSBPRE, Bits)                        'Get SHIFTIN DataValue
      outa[SLpin] := %0                                                         'Set Shift / Load pin in load mode "0"
      
      outa[23..16] := DataValue                                                 'DEBUG - Lightup the LED's corresponding to the data
                                                                                '        LED23 = MSB
                                                                                '        LED16 = LSB
'------------------------------------------------------------------------------------------------------------------------------
{{
                                                                                
Notes:
Consecutive SHIFTIN/SHIFTOUT updates through Spin at 80 MHz is about 14kHz (Bit rate about 112k) 

Consecutive SHIFTIN/SHIFTOUT updates through Assembly at 80 MHz is about 310kHz (Bit rate about 2.5M)

}}

      